local myname="ZifnabsHUD"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={hud=Me} else ZifnabsMod.hud=Me end
local mod
local L
local db
local mydb
local widget={}
local queue={}
local timer=0
local scroll=0
local tick={time=0,flip=0}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	if not fwinfo.dbpc.hud then fwinfo.dbpc.hud={active=true,write2chat=false,scroll=5, queuescroll=1.5} end
	mydb=fwinfo.dbpc.hud
	widget.hud={}
	for t=1,3,1 do
		widget.hud[t]={text=mod.ui:addText(myname.."_Text_1",600,30,UIParent,"CENTER","TOP",0,-40-30*t+(t*t),25-(t*t),"CENTER","TOP")}
		widget.hud[t].text:SetTextColor(1,(t-1)/2,0)
		-- TODO create icon holder
	end
	Me:SetActive(mydb.active)
end

-- --------------------------------------------------------------------------------------
-- SET ACTIVE
-- --------------------------------------------------------------------------------------
function Me:SetActive(set)
	mydb.active=set
	if set then 
		mod.core:Register4Event("ONUPDATE","hud",Me.OnUpdate)
	else
		mod.core:DeRegister4Event("ONUPDATE","hud",Me.OnUpdate)
	end
end

-- --------------------------------------------------------------------------------------
-- WRITE
-- --------------------------------------------------------------------------------------
function Me:write(text,sound,icon) 
	text=mod.f:Trim(text)
	local chat=(text~="" and (mydb.write2chat or not mydb.active))
	local hud=((text~="" or icon) and mydb.active)
	if hud then queue[1+#queue]={text=text,icon=icon} end
	if chat then mod.f:Print(text) end
	if chat or hud then mod.f:Sound(sound) end
end

-- --------------------------------------------------------------------------------------
-- ONUPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	timer=timer+elapsed
	if timer>tick.time+0.3 then
		tick.time=timer
		tick.flip=1-tick.flip
		widget.hud[1].text:SetTextColor(1,tick.flip,0)
		widget.hud[2].text:SetTextColor(1,0.5+0.5*tick.flip,0)
	end
	if timer-scroll>=mydb.scroll or (#queue>0 and timer-scroll>mydb.queuescroll) then
		widget.hud[3].text:SetText(widget.hud[2].text:GetText())
		widget.hud[2].text:SetText(widget.hud[1].text:GetText())
		if #queue==0 then widget.hud[1].text:SetText("")
		else
			widget.hud[1].text:SetText(queue[1].text)
			if queue[1].sound then mod.f:Sound(queue[1].sound) end
			tremove(queue,1)
		end
		scroll=timer
	end
end